﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Threading;

namespace howto_thread_use_form_methods
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // This value is incremented by the thread.
        public int Value = 0;

        // Make and start a new counter object.
        private int thread_num = 0;
        private void btnStartThread_Click(object sender, EventArgs e)
        {
            // Make a new counter object.
            Counter new_counter = new Counter(this, thread_num);
            thread_num++;

            // Make a thread to run the object's Run method.
            Thread counter_thread = new Thread(new_counter.Run);

            // Make this a background thread so it automatically
            // aborts when the main program stops.
            counter_thread.IsBackground = true;

            // Start the thread.
            counter_thread.Start();
        }

        // Add the text to the results.
        // The form provides this service because the
        // thread cannot access the form's controls directly.
        public void DisplayValue(string txt)
        {
            lstResults.Items.Add(txt);
            lstResults.SelectedIndex = lstResults.Items.Count - 1;
        }
    }
}
